﻿using DbCommon.BusinessCore.DbCore;
using DbCommon.Enties.DbModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DbCommon.BusinessCore.BaseCore
{
    public class PmsTaskInfoManager : DbContext<PmsTaskInfo>
    {
        public void Init()
        {
            //If no exist create datebase 
            //Db.DbMaintenance.CreateDatabase();

            if (!Db.DbMaintenance.IsAnyTable("PmsTaskInfo", false))
            {
                //Create tables
                Db.CodeFirst.InitTables(typeof(PmsTaskInfo));
            }
        }

        public bool DeleteOldData(int day = 1)
        {
            return CurrentDb.Delete(d => d.CreateTime < DateTime.Now.AddDays(day * -1));
        }

        public List<PmsTaskInfo> Query()
        {
            return Db.Queryable<PmsTaskInfo>()
                .OrderBy(d => d.CreateTime, SqlSugar.OrderByType.Asc)
                .ToList();
        }
    }
}
