﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DbCommon.Enties.DbModels
{
    [SugarTable("t_wh_locationProperty")]
    public class LocationProperty
    {
        public string WareHouseCode { get; set; }

        [SugarColumn(IsPrimaryKey = true)]
        public string LocationCode { get; set; }
        public int Mark { get; set; }
        public int Priority { get; set; }
        public LocationStatus Status { get; set; }

        [SugarColumn(IsNullable = true)]
        public string Active { get; set; }

        [SugarColumn(IsNullable = true)]
        public string ModifyUser { get; set; }

        [SugarColumn(IsNullable = true)]
        public string ModifyTime { get; set; }

        [SugarColumn(IsNullable = true)]
        public string Area { get; set; }

        public int RowIndex { get; set; }
        public int ColumnIndex { get; set; }
        public int LayerIndex { get; set; }


        //[SugarColumn(ColumnName = "Attribute1", IsNullable = true)]
        //public string DisplayId { get; set; }//显示ID

        //[SugarColumn(ColumnName = "Attribute2", IsNullable = true)]
        //public string TaskType { get; set; }//叫料任务类型



        [SugarColumn(ColumnName = "Attribute3", IsNullable = true)]
        public string MaterialBarcode { get; set; }//PDA扫码

        [SugarColumn(ColumnName = "Attribute4", IsNullable = true)]
        public string MaterialId { get; set; }//物料ID

        [SugarColumn(ColumnName = "Attribute5", IsNullable = true)]
        public string MaterialName { get; set; }//物料名称

        [SugarColumn(ColumnName = "Attribute6", IsNullable = true)]
        public string MaterialNumber { get; set; }//物料数量

        [SugarColumn(ColumnName = "Attribute7", IsNullable = true)]
        public string MaterialWeight { get; set; }//物料重量

        [SugarColumn(ColumnName = "Attribute8", IsNullable = true)]
        public string BatchNumber { get; set; }//批次号

        [SugarColumn(ColumnName = "Attribute9", IsNullable = true)]
        public string CurrentTaskID { get; set; }//当前锁定库位的任务号

        //[SugarColumn(ColumnName = "Attribute10", IsNullable = true)]
        //public string StatusBackup { get; set; }//状态备份
    }


    public enum LocationStatus
    {
        None,
        Filled,
        Empty,
        Locked,
        LineCall,
        LockedFinally,

        Exception = 255
    }
}
