﻿using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Device.CommandCallback;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.Extenions
{
    public static class ModelExtenions
    {
        public static StepData GetCurrentStepInfo(this TaskData taskData)
        {
            return taskData.StepList?.FirstOrDefault(d => d.StepID == taskData.CurrentStepID);
        }

        public static string ToSimpleString(this TaskData taskInfo)
        {
            return $"【{taskInfo.TaskID} {taskInfo.ParentTaskID} {taskInfo.TaskState} {taskInfo.TaskBook} Step{taskInfo.CurrentStepID} AGV{taskInfo.Carrier} AGVType{taskInfo.CarrierType} {taskInfo.CreateTime} BindAGV{taskInfo.BindingAGVNumber}】";
        }

        public static string ToSimpleString(this StepData stepInfo)
        {
            return $"{stepInfo.TaskID} Step{stepInfo.StepID} {stepInfo.SystemStepState} {stepInfo.StepMoveName} {stepInfo.WareHouseID} S:{stepInfo.StationID} V:{stepInfo.VertexID} AGV:{stepInfo.AgvBehavior}({stepInfo.Param1},{stepInfo.Param2},{stepInfo.Param3}) PMS:{stepInfo.PmsBehavior}";
        }

        public static string ToSimpleString(this ResultAgvData agvData)
        {
            return $"{agvData.AgvID}# Online:{agvData.Online} E:{agvData.GraphEdge} V:{agvData.GraphVertex} LogicBits:{agvData.LogicBits} U:{agvData.LogicBits.GetBitVaule(9)} D:{agvData.LogicBits.GetBitVaule(10)}";
        }

        public static string ToSimpleString(this InfoRollerHx data)
        {
            return $"滚筒台{data.DeviceId} 有效{data.DataValid} 报警{data.AlarmCode} 无动作{data.NoAction} 已动作{data.Rotating} 空{data.Empty} 满{data.Full}";
        }
    }
}
