﻿using Newtonsoft.Json;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.Service
{
    public class CallbackService
    {
        public string TaskCancelNotice(object dataObject)
        {
            string dataObjectStr = dataObject.ToString();

            var taskInfo = JsonConvert.DeserializeObject<TaskData>(dataObjectStr);
            CLog.Instance.TaskLog.WirteInfoCaller($"{taskInfo.TaskID} 任务取消（API通知）");

            return string.Empty;
        }

        public string SendTransparentData(object dataObject)
        {
            string dataObjectStr = dataObject.ToString();
            var data = JsonConvert.DeserializeObject<RequestTransparentData>(dataObjectStr);

            //string dataHexString = data.Data.ToHexString();
            //CLog.Instance.TaskLog.WirteDebugCaller($"收到透传数据 {dataHexString}");

            CommunicationVcu.Instance.Received(data.Data);
            return string.Empty;
        }

        public string TaskStepStart(object dataObject)
        {
            string dataObjectStr = dataObject.ToString();

            var stepData = JsonConvert.DeserializeObject<StepData>(dataObjectStr);
            CLog.Instance.TaskLog.WirteInfoCaller($"{stepData.TaskID} {stepData.StepID} 任务步骤开始（API通知）");

            return string.Empty;
        }

        public string TaskStepEnd(object dataObject)
        {
            string dataObjectStr = dataObject.ToString();

            var stepData = JsonConvert.DeserializeObject<StepData>(dataObjectStr);
            CLog.Instance.TaskLog.WirteInfoCaller($"{stepData.TaskID} {stepData.StepID} 任务步骤结束（API通知）");

            return string.Empty;
        }
    }
}
