﻿using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Models;
using System;
using System.Collections.Generic;
using System.Runtime.CompilerServices;

namespace ProjectManagementSystem.Common.Service
{
    public interface IPmsApi
    {
        bool Status { get; set; }

        WebMgrResponse CustomApiGet(string apiName, object pars, object body);
        WebMgrResponse CustomApiPost(string apiName, object pars, object body);

        bool AddOperate(int behavior, string remark);
        bool AddWarehouse(string wareHouseID, int stationID, int r1 = 0, int r2 = 0, int r3 = 0, string groupId = "");
        bool CarrierPause(int agvId);
        bool CarrierResume(int agvId);
        bool DeleteTaskStep(string taskId, int stepId);

        List<ResultAgvData> GetAllCarrier();
        ResultAgvData GetCarrier(int agvId);
        List<Freight> GetFreights(int agvId);
        List<StepData> GetHistoryStepList(string taskId);
        TaskData GetHistoryTaskData(string taskId);
        List<TaskData> GetHistoryTaskList(DateTime startTime, DateTime endTime);
        List<OperateInfo> GetOperateList(string name);
        Dictionary<int, RequestPmsTaskInfo> GetPmsBehavior();
        List<StepData> GetStepList(string taskId);
        List<TaskBookInfo> GetTaskBookList();
        TaskData GetTaskData(string taskId);
        List<TaskData> GetTaskDataList();
        List<TaskData> GetTaskList();
        List<WarehouseGroupInfo> GetwarehouseGroupType();
        List<WarehouseInfo> GetWarehouseListInfo(string warehouseId);
        MapData GetMapData();

        bool SendTransparentData(int agvId, byte[] data);
        bool SetCarrierLogicBits(int agvId, int bit, int value);
        bool SetCarrierLogicValues(int agvId, int bit, int[] values);
        bool SetPmsBehaviorFinish(string taskId, int agvId, int pmsBehavior);
        bool SetTaskPriority(string taskId, int priority);

        bool TaskAdd(MidTaskInfoEx data, [CallerMemberName] string logKeyWord = null);
        WebMgrResponse TaskAddResponse(MidTaskInfoEx data);
        bool TaskAddStep(string TaskId, int Station, bool IsAgvBehavior, int AgvBehavior, int Param1, int PmsBehavior);
        bool TaskCancel(string taskId);
        bool TaskChangeAssignAGV(string taskId, int agvId);
        bool TaskChangeRely(string taskId, string parentTaskId);
        bool TaskContinueReceipt();
        bool TaskEnd(string taskId);
        bool TaskPause(string taskId);
        bool TaskResume(string taskId);
        bool TaskStepSkip(string taskId, int stepId);
        bool TaskStopReceipt();

        bool UpdateOperate(OperateInfo operateInfo);
        bool UpdateStepAgvBehavior(string TaskId, int StepId, bool IsAgvBehavior, int AgvBehavior, int Param1, int Param2, int Param3, int PmsBehavior);
        bool UpdateStepWarehouse(string taskId, int stepId, string warehouseId);
        bool UpdateWarehouse(string wareHouseID, int stationID, int r1, int r2, int r3, string groupId);
    }
}