﻿using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.WebApi;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectManagementSystem.Common.Extenions;

namespace ProjectManagementSystem.Common.TaskBookEvent
{
    public class AsyncBehaviorRollerHxRecv : AsyncBehavior
    {

        public override bool CustomOperator(TaskData taskData, StepData stepInfo)
        {
            int id = ExcelConfig.Instance.GetRouteConfig(stepInfo.WareHouseID).RollerID;
            var dict = DeviceControl.Instance.Communication.InfoRollerHxDictionary;
            if (!dict.ContainsKey(id))
            {
                Log(taskData, stepInfo, "获取滚筒台数据失败");
                return false;
            }

            var data = dict[id];
            if (data.DataValid
                && data.NoAction
                && data.Full
                && data.AlarmCode == 0)
            {
                Log(taskData, stepInfo, data.ToSimpleString());
                return true;
            }
            else
            {
                ushort actionCode = 0x01;

                Log(taskData, stepInfo, $"{data.ToSimpleString()}，发送操作0x{actionCode:X2}");
                DeviceControl.Instance.RollerHxOperate(id, actionCode);
            }

            return false;
        }
    }
}
