﻿using DbCommon.BusinessCore.BaseCore;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.DataCache;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models.Crms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.TaskBookEvent
{
    public class TaskBookBehavior_63006 : BaseTaskBookBehaviorV2
    {
        public TaskBookBehavior_63006() : base(63006, "等待平板放行")
        {
        }

        public override bool TaskBookOperator(TaskData taskDetailInfo, StepData stepInfo)
        {
            try
            {
                //可调用接口放行
                var dict = CacheStringToObject.ReleaseAgvDtoDict;
                if (dict.ContainsKey(stepInfo.WareHouseID))
                {
                    var releaseAgvData = dict[stepInfo.WareHouseID];
                    if (releaseAgvData.DataValid)
                    {
                        releaseAgvData.Status = 1;
                        Log(taskDetailInfo, stepInfo, $"已{Remark}");
                        return true;
                    }
                }

                Log(taskDetailInfo, stepInfo, Remark);
                return false;

                //int[] marks = stepInfo.WareHouseID.GetLocationMember("放行叫料路线").ToValueArray<int>();
                //if (marks == null || marks.Length == 0)
                //{
                //    Log(taskDetailInfo, stepInfo, "未配置放行叫料路线，步骤完成");
                //    return true;
                //}

                //int count = DeviceControl.Instance.Communication.InfoBoxDictionary.Values
                //    .Count(d => d.DataValid && marks.Contains(d.Route) && d.BoxCalled);

                //if (count < marks.Length)
                //{
                //    Log(taskDetailInfo, stepInfo, "等待放行");
                //    return false;
                //}

                //for (int j = 0; j < 2; j++)
                //{
                //    for (int i = 0; i < marks.Length; i++)
                //    {
                //        DeviceControl.Instance.CallBoxLightOff(marks[i]);
                //        System.Threading.Thread.Sleep(100);
                //    }
                //}

                //Log(taskDetailInfo, stepInfo, $"已放行，灭灯");
                //return true;
            }
            catch (Exception ex)
            {
                LogException(ex);
            }
            return false;
        }
    }
}
