﻿using DbCommon.BusinessCore.BaseCore;
using DbCommon.Enties.DbModels;
using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.WebApi;
using ProjectManagementSystem.Common.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Service;
using ProjectManagementSystem.Common.Models.Crms;

namespace ProjectManagementSystem.Common.TaskBookEvent
{

    public class TaskBookBehavior_63008 : BaseTaskBookBehaviorV2
    {
        //LocationPropertyManager locationManager = new LocationPropertyManager();

        public TaskBookBehavior_63008() : base(63008, "续接任务")
        {
        }

        public override bool TaskBookOperator(TaskData taskDetailInfo, StepData stepInfo)
        {
            try
            {
                //var nextLocation = stepInfo.WareHouseID.GetLocationMember("续接取货位置");
                //if (string.IsNullOrEmpty(nextLocation))
                //{
                //    Log(taskDetailInfo, stepInfo, $"未配置续接取货位置");
                //    return false;
                //}

                //if (stepInfo.WareHouseID == "上料人工")
                //{
                //    var config = ExcelConfig.Instance.GetRouteConfig(stepInfo.WareHouseID);
                //    if (config != null
                //        && config.PackPlcToAgv != null)
                //    {
                //        var ret = config.PackPlcToAgv.ReleaseAgv(config, out string msg);

                //        if (ret != 20000)
                //        {
                //            Log(taskDetailInfo, stepInfo, $"等待放行 {msg}");
                //            return false;
                //        }
                //    }
                //}

                if (stepInfo.WareHouseID.Contains("场景一空料车缓存"))
                {
                    PmsTaskInfoDto data = new PmsTaskInfoDto();
                    data.LocationCode = "场景一满料车缓存";
                    data.TargetLocationCode = "机械手1";
                    data.ParentTaskId = taskDetailInfo.TaskID;
                    data.Carrier = taskDetailInfo.Carrier;

                    var result = PmsTaskService.Instance.TaskAddNoCheck(data, new string[] { });
                    //return result.code == 20000;
                }
                else if (stepInfo.WareHouseID.Contains("机械手"))
                {

                    PmsTaskInfoDto data = new PmsTaskInfoDto();
                    data.LocationCode = "场景一空料车缓存";

                    data.TargetWareHouseCode = "场景一空料车放置";
                    data.ParentTaskId = taskDetailInfo.TaskID;
                    data.Carrier = taskDetailInfo.Carrier;

                    var result = PmsTaskService.Instance.TaskAdd(data);
                    //return result.code == 20000;
                }
                else if (stepInfo.WareHouseID.Contains("场景一空料车放置"))
                {
                    PmsTaskInfoDto data = new PmsTaskInfoDto();
                    data.WareHouseCode = "场景一满料车放置";
                    data.TargetLocationCode = "场景一满料车缓存";
                    data.ParentTaskId = taskDetailInfo.TaskID;
                    data.Carrier = taskDetailInfo.Carrier;

                    var result = PmsTaskService.Instance.TaskAdd(data);
                    //return result.code == 20000;
                }
                else if (stepInfo.WareHouseID.Contains("场景二满料车放置"))
                {
                    string warehouseid = taskDetailInfo.StepList.OrderBy(p => p.StepID).First().WareHouseID;
                    if (warehouseid.Contains("A"))
                    {
                        PmsTaskInfoDto data = new PmsTaskInfoDto();
                        data.WareHouseCode = "场景二空料车放置A";
                        data.TargetWareHouseCode = "场景二叫料工位A";
                        data.ParentTaskId = taskDetailInfo.TaskID;
                        data.Carrier = taskDetailInfo.Carrier;

                        var result = PmsTaskService.Instance.TaskAdd(data);
                    }
                    else if (warehouseid.Contains("B"))
                    {
                        PmsTaskInfoDto data1 = new PmsTaskInfoDto();
                        data1.WareHouseCode = "场景二空料车放置B";
                        data1.TargetWareHouseCode = "场景二叫料工位B";
                        data1.ParentTaskId = taskDetailInfo.TaskID;
                        data1.Carrier = taskDetailInfo.Carrier;

                        var result1 = PmsTaskService.Instance.TaskAdd(data1);
                    }
                    else if (warehouseid.Contains("C"))
                    {
                        PmsTaskInfoDto data2 = new PmsTaskInfoDto();
                        data2.WareHouseCode = "场景二空料车放置C";
                        data2.TargetWareHouseCode = "场景二叫料工位C";
                        data2.ParentTaskId = taskDetailInfo.TaskID;
                        data2.Carrier = taskDetailInfo.Carrier;

                        var result2 = PmsTaskService.Instance.TaskAdd(data2);
                    }
                }
                //PmsTaskInfoDto data = new PmsTaskInfoDto();
                //data.WareHouseCode = "场景二空料车放置A";
                //data.TargetWareHouseCode = "场景二叫料工位A";
                //data.ParentTaskId = taskDetailInfo.TaskID;
                //data.Carrier = taskDetailInfo.Carrier;

                //var result = PmsTaskService.Instance.TaskAdd(data);
                //if (result.code != 20000)
                //{
                //    PmsTaskInfoDto data1 = new PmsTaskInfoDto();
                //    data1.WareHouseCode = "场景二空料车放置B";
                //    data1.TargetWareHouseCode = "场景二叫料工位B";
                //    data1.ParentTaskId = taskDetailInfo.TaskID;
                //    data1.Carrier = taskDetailInfo.Carrier;

                //    var result1 = PmsTaskService.Instance.TaskAdd(data1);
                //    if (result1.code != 20000)
                //    {
                //        PmsTaskInfoDto data2 = new PmsTaskInfoDto();
                //        data2.WareHouseCode = "场景二空料车放置C";
                //        data2.TargetWareHouseCode = "场景二叫料工位C";
                //        data2.ParentTaskId = taskDetailInfo.TaskID;
                //        data2.Carrier = taskDetailInfo.Carrier;

                //        var result2 = PmsTaskService.Instance.TaskAdd(data2);
                //        //return result2.code != 20000;
                //    }
                //return true;
                //return true;

                return true;
            }
            catch (Exception ex)
            {
                LogException(ex);
            }
            return false;
        }

        //public override bool TaskBookOperator(TaskData taskDetailInfo, StepData stepInfo)
        //{
        //    try
        //    {

        //        //空托盘回原位置
        //        string targetLocation = taskDetailInfo.StepList
        //            .OrderBy(d => d.StepID)
        //            .FirstOrDefault(d => !string.IsNullOrWhiteSpace(d.WareHouseID))
        //            .WareHouseID;

        //        PmsTaskInfoDto data = new PmsTaskInfoDto();
        //        //data.WareHouseCode = locationData.WareHouseCode;
        //        data.LocationCode = stepInfo.WareHouseID;
        //        //data.TargetWareHouseCode = "原材料";
        //        data.TargetLocationCode = targetLocation;
        //        data.ParentTaskId = taskDetailInfo.TaskID;
        //        data.Carrier = taskDetailInfo.Carrier;

        //        var result = PmsTaskService.Instance.TaskAdd(data);
        //        if (result.code != 20000)
        //        {
        //            Log(taskDetailInfo, stepInfo, $"续接任务失败 {result.message}");
        //            return false;
        //        }

        //        return true;
        //    }
        //    catch (Exception ex)
        //    {
        //        LogException(ex);
        //    }
        //    return false;
        //}
    }
}
