﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Config;

namespace ProjectManagementSystem.Common.TaskBookEvent
{
    public class TaskBookBehavior_63009 : TaskBookBehavior_63007
    {
        //LocationPropertyManager locationManager = new LocationPropertyManager();

        public TaskBookBehavior_63009() : base(63009, "更改步骤库位(模组)")
        {
        }

        protected override bool CheckAllowEnter(string location)
        {
            string plcAllowEnter = location.GetLocationMember("PLC工位状态");
            if (string.IsNullOrEmpty(plcAllowEnter))
            {
                return true;
            }

            var config = ExcelConfig.Instance.GetRouteConfig(location);
            if (config == null
            || config.PlcReadWrite == null
            || config.PlcConnected == false)
            {
                return false;
            }

            var read = config.PlcReadWrite.ReadInt16(plcAllowEnter);
            return read.IsSuccess && read.Content == 0;
        }
    }
}
