﻿using DbCommon.BusinessCore.BaseCore;
using DbCommon.Enties.DbModels;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.WebApi;
using ProjectManagementSystem.Common.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectManagementSystem.Common.Service;

namespace ProjectManagementSystem.Common.TaskEvent
{
    public class CTaskEvent : CTaskEventBase
    {
        public override void TaskCustomProc(List<TaskData> taskDataList)
        {
        }

        public override void TaskStateChanged(TaskData taskInfo, TaskData lastTaskInfo)
        {
        }
        public override void TaskFinished(TaskData taskInfo)
        {
            CLog.Instance.GetAgvLog(taskInfo.Carrier).WriteInfo($"{taskInfo.TaskID} 任务完成");
        }

        public override void TaskCanceled(TaskData taskInfo)
        {
            CLog.Instance.GetAgvLog(taskInfo.Carrier).WriteInfo($"{taskInfo.TaskID} 任务取消");

            RecoverLocationStatus(taskInfo);
        }

        public override void TaskTerminated(TaskData taskInfo)
        {
            CLog.Instance.GetAgvLog(taskInfo.Carrier).WriteInfo($"{taskInfo.TaskID} 任务终止");

            RecoverLocationStatus(taskInfo);
        }

        public override void TaskExceptioned(TaskData taskInfo)
        {
            CLog.Instance.GetAgvLog(taskInfo.Carrier).WriteInfo($"{taskInfo.TaskID} 任务异常");

            RecoverLocationStatus(taskInfo);
        }

        public override void TaskBecomeHistory(TaskData taskInfo)
        {
            CLog.Instance.GetAgvLog(taskInfo.Carrier).WriteInfo($"{taskInfo.TaskID} 任务已转入历史任务，任务状态：{taskInfo.TaskState}（可能原因：AGVS重启）");

            RecoverLocationStatus(taskInfo);
        }

        private void RecoverLocationStatus(TaskData taskInfo)
        {
            var posArray = taskInfo.StepList?
                .OrderBy(d => d.StepID)?
                .Select(d => d.WareHouseID)?
                .Distinct()?
                .ToList();

            if(posArray == null) return;

            for (int i = 0; i < posArray.Count; i++)
            {
                string location = posArray[i];

                PmsTaskService.Instance.UnlimitLocation(taskInfo.TaskID, location);

                var config = Common.Config.ExcelConfig.Instance.GetRouteConfig(location);
                if(config != null
                    && config.Route > 0)
                {
                    DeviceControl.Instance.CallBoxLightOff(config.Route);
                }
            }
        }
    }
}
