﻿using DbCommon.BusinessCore.BaseCore;
using DbCommon.Enties.DbModels;
using ProjectManagementSystem.Common.Function;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Tibco.TibcoMsg;
using System;
using System.Collections.Generic;
using System.Data;
using System.Xml;

namespace ProjectManagementSystem.Common.Tibco
{
    public class TibcoReply
    {
        #region 成员变量
        private static object m_instanceSyncLock = new object();            // 同步实例对象
        private static TibcoReply m_instance;                            // 该类实例对象
        #endregion
        public static TibcoReply Instance
        {
            get
            {
                lock (m_instanceSyncLock)
                {
                    if (m_instance == null)
                    {
                        m_instance = new TibcoReply();
                    }
                    return m_instance;
                }
            }
        }

        public string GetMESMessage(string MES_message, out string replySubjectName, out string messageName)
        {
            string responseMsg = "";
            XmlDocument ReceiveXmlData = new XmlDocument();
            ReceiveXmlData.LoadXml(MES_message);
            #region 获取有效信息(HEAD)
            messageName = ReceiveXmlData.SelectSingleNode("MESSAGE/HEADER/MESSAGENAME").InnerText;
            replySubjectName = ReceiveXmlData.SelectSingleNode("MESSAGE/HEADER/REPLYSUBJECTNAME").InnerText;
            string transaction = ReceiveXmlData.SelectSingleNode("MESSAGE/HEADER/TRANSACTIONID").InnerText;
            #endregion

            switch (messageName)
            {
                case "GetICSStateRequest":
                    {
                        //responseMsg = getGetICSStateReplyXMLString();
                    }
                    break;
                case "RequestTransportJobRequest":
                    {
                        RequestTransportJobRequest(MES_message);
                    }
                    break;
                default:
                    break;
            }
            return responseMsg;
        }


        public void RequestTransportJobRequest(string MES_message)
        {
            var reply = XmlTools.XmlDeserialize<RequestTransportJobRequest>(MES_message);
            if(reply == null
                || reply.HEADER == null
                || reply.BODY == null)
            {
                CLog.Instance.TibcoLog.WriteInfo("RequestTransportJobRequest反序列化失败");
                return;
            }
        }

    }
}
