﻿using ProjectManagementSystem.Device.Core;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Device.CommandCallback
{
    public class InfoRollerHx : BaseInfo, IDeviceCommandCallback
    {
        public int DeviceId { get; set; }
        public int Function { get; set; }

        public int AlarmCode { get; set; }
        public int FFULevel { get; set; }
        public int FFUStatus { get; set; }

        public int LightStatus { get; set; }
        public int DeviceStatus { get; set; }

        public bool NoAction { get; set; }
        public bool Rotating { get; set; }
        public bool Empty { get; set; }
        public bool Full { get; set; }


        public int ActionCode { get; set; }
        public DateTime Recv0x52Time { get; set; }


        public void Deserialize(byte[] data)
        {
            DeviceId = data[7];
            Function = data[1];

            switch (Function)
            {
                case 0x52:
                    Recv0x52Time = DateTime.Now;
                    break;
                case 0x54:

                    AlarmCode = data[3];
                    FFULevel = data[4];
                    FFUStatus = data[5];
                    LightStatus = data[9];
                    DeviceStatus = data[10];

                    NoAction = (DeviceStatus & 0x01) > 0;
                    Rotating = (DeviceStatus & 0x02) > 0;
                    Empty = (DeviceStatus & 0x04) > 0;
                    Full = (DeviceStatus & 0x08) > 0;

                    ActionCode = data[11];

                    LastUpdateTime = DateTime.Now;
                    break;
                default:
                    break;
            }
        }
    }
}
