﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Controllers;
using System.Web.Http.Filters;

namespace ProjectManagementSystem.WebApi.Filters
{
    public class ValidateModelAttribute : ActionFilterAttribute
    {
        public override void OnActionExecuting(HttpActionContext actionContext)
        {
            if (actionContext.ModelState.IsValid == false)
            {
                var webMgrResponse = new { code = HttpStatusCode.BadRequest, message = actionContext.ModelState.Values?.First()?.Errors[0]?.ErrorMessage };
                actionContext.Response = actionContext.Request.CreateResponse(HttpStatusCode.BadRequest, webMgrResponse);
            }
        }
    }
}
