﻿using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.TaskBookEvent;
using ProjectManagementSystem.Common.TaskEvent;
using ProjectManagementSystem.WebApi.Service;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Enterance
{
    public class SystemEntranceV2
    {
        public WebApiServerHost webApiServerHost = new WebApiServerHost();

        public SystemEntranceV2()
        {
            if (ExcelConfig.Instance == null)
            {
                string logContext = "Excel配置加载失败，启动失败";
                KillCurrentProcess(logContext);
                return;
            }

            if (!SystemInitialize.InitDataSource())
            {
                string logContext = "数据库初始化失败，启动失败";
                KillCurrentProcess(logContext);
                return;
            }

            //if (RouteCalled.Instance == null)
            //{
            //    string logContext = "初始化RouteCalled失败，启动失败";
            //    KillCurrentProcess(logContext);
            //    return;
            //}

            if (PlcControl.Instance == null)
            {
                string logContext = "初始化Plc失败，启动失败";
                KillCurrentProcess(logContext);
                return;
            }

            if (DeviceControl.Instance == null)
            {
                string logContext = "初始化DeviceControl失败，启动失败";
                KillCurrentProcess(logContext);
                return;
            }

            //if (!webApiServerHost.StartServer())
            //{
            //    string logContext = "初始化WebApi失败，启动失败";
            //    KillCurrentProcess(logContext);
            //    return;
            //}

            if (TaskBehavior.Instance == null)
            {
                string logContext = "初始化TaskBehavior失败，启动失败";
                KillCurrentProcess(logContext);
                return;
            }

            if (PackControl.Instance == null)
            {
                string logContext = "初始化PackControl失败，启动失败";
                KillCurrentProcess(logContext);
                return;
            }

            TaskBookRegister taskBookRegister = new TaskBookRegister();

            Task.Factory.StartNew(() =>
            {
                SystemInitialize.SystemStarted();

                SystemInitialize.InitWMS();
                SystemInitialize.InitWareHouse();
                SystemInitialize.InitOperate();
                SystemInitialize.InitAsyncBehavior();
                //SystemInitialize.InitLocationXY();
                //SystemInitialize.InitPmsAutoupdateXml();

                CTaskEvent taskEvent = new CTaskEvent();
            });
        }

        private void KillCurrentProcess(string logContext)
        {
            System.Windows.Forms.MessageBox.Show(logContext);
            System.Windows.Forms.Application.Exit();

            Process[] process = Process.GetProcesses();
            Process currentProcess = Process.GetCurrentProcess();
            for (int idx = 0; idx < process.Count(); idx++)
            {
                if (process[idx].ProcessName == currentProcess.ProcessName)
                {
                    process[idx].Kill();
                }
            }
            return;
        }
    }
}
