﻿using Newtonsoft.Json.Linq;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Function;
using ProjectManagementSystem.Common.Logger;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectManagementSystem.UI
{
    public partial class AppSettingUI : UserControl, IDisplayUI
    {
        private string[] keyArray = new string[]
        { "AssignmentPointMaxTaskCount" };

        public AppSettingUI()
        {
            InitializeComponent();
        }

        public bool Init()
        {
            dataGridUI1.dataGridView1.CellClick += DataGridView1_CellClick;
            return true;
        }

        private void DataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            textBox1.Text = dataGridUI1.GetCurrentColValue("key");
            textBox2.Text = dataGridUI1.GetCurrentColValue("value");
        }

        public void UpdateDisplay()
        {
            if (!this.Visible) return;

            List<JObject> JDataList = new List<JObject>();
            var settings = AppSetting.GetSettingsCollection();
            foreach (var item in settings.AllKeys)
            {
                if(!keyArray.Contains(item))
                {
                    continue;
                }

                var jData = new JObject();
                jData["key"] = item;
                jData["value"] = settings[item].Value;
                JDataList.Add(jData);
            }

            dataGridUI1.ShowDataGrid(JDataList);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                string key = textBox1.Text;
                string value = textBox2.Text;

                var result = AppSetting.TrySaveValue(key, value);
                MessageBox.Show($"{(sender as Control).Text}{result.ToChineseString()}", "提示");
            }
            catch (Exception ex)
            {
                CLog.Instance.SystemLog.WriteException("UI", ex);
                MessageBox.Show(ex.Message, "提示", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
