﻿using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Logger;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectManagementSystem.UI
{
    public partial class DebugPlcUI : UserControl, IDisplayUI
    {
        public DebugPlcUI()
        {
            InitializeComponent();
        }

        public bool Init()
        {
            dataGridUI1.dataGridView1.CellClick += DataGridView1_CellClick;
            return true;
        }

        private void DataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            textBox1.Text = dataGridUI1.GetCurrentColValue("库位号");
        }

        public void UpdateDisplay()
        {
            if (!this.Visible) return;

            //var dataList = PlcControl.Instance.ReadPlcInfo();
            //dataGridUI1.ShowDataGrid(dataList);
        }

        private async void button1_Click(object sender, EventArgs e)
        {
            try
            {
                button1.Enabled = false;
                var dataList = await Task.Run(() =>
                {
                    return PlcControl.Instance.ReadPlcInfo();
                });

                if (dataList == null) return;
                dataGridUI1.ShowDataGrid(dataList);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "提示", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

            button1.Enabled = true;
        }
    }
}
