﻿using Microsoft.Xaml.Behaviors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace ProjectManagementSystemView.Infrastructure.Behaviors
{
    public class MouseClickSelectedItemBehavior : Behavior<FrameworkElement>
    {
        public object SelectedItem
        {
            get { return (object)GetValue(SelectedItemProperty); }
            set { SetValue(SelectedItemProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SelectedItem.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SelectedItemProperty =
            DependencyProperty.Register("SelectedItem", typeof(object), typeof(MouseClickSelectedItemBehavior));


        private void OnMouseUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            if (e.Source is FrameworkElement element && element.DataContext is object v)
            {
                SelectedItem = v;
            }
        }

        protected override void OnAttached()
        {
            AssociatedObject.MouseUp += OnMouseUp;
        }

        protected override void OnDetaching()
        {
            AssociatedObject.MouseUp -= OnMouseUp;
        }
    }
}
