﻿using DbCommon.Enties.DbModels;
using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media.Media3D;

namespace ProjectManagementSystemView.Infrastructure.Models
{
    [AddINotifyPropertyChangedInterface]
    public class VmLocationProperty
    {
        public string WareHouseCode { get; set; }
        public string LocationCode { get; set; }
        public int Mark { get; set; }
        public int Priority { get; set; }
        public LocationStatus Status { get; set; }
        public string Active { get; set; }
        public string ModifyUser { get; set; }
        public string ModifyTime { get; set; }
        public string Area { get; set; }

        public int RowIndex { get; set; }
        public int ColumnIndex { get; set; }
        public int LayerIndex { get; set; }

        public string MaterialBarcode { get; set; }//PDA扫码
        public string MaterialId { get; set; }//物料ID
        public string MaterialName { get; set; }//物料名称
        public string MaterialNumber { get; set; }//物料数量
        public string MaterialWeight { get; set; }//物料重量
        public string BatchNumber { get; set; }//批次号
        public string CurrentTaskID { get; set; }//当前锁定库位的任务号

        public double CX { get; set; }
        public double CY { get; set; }
        public double CZ { get; set; }



        public double X { get; set; }
        public double Y { get; set; }
        public double XLength { get; set; }
        public double YLength { get; set; }
        public double ZLength { get; set; }

        public double DragX { get; set; }
        public double DragY { get; set; }

        public object Self => this;
        public Point3D TextPosition => new Point3D(CX, CY, CZ + ZLength / 2 + 0.4);
    }
}
