﻿using ProjectManagementSystem.Common.Models.Crms;
using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystemView.Infrastructure.Models
{
    [AddINotifyPropertyChangedInterface]
    public class VmTaskData
    {
        public ObservableCollection<VmStepData> StepList { get; set; }

        public string ID { get; set; }
        public string TaskID { get; set; }
        public string ParentTaskID { get; set; }
        public string OrderID { get; set; }
        public string Name { get; set; }
        public ETaskState TaskState { get; set; }
        public string TaskBook { get; set; }
        public string AllWarehouse { get; set; }
        public int CurrentStepID { get; set; }
        public bool IsException { get; set; }
        public bool IsLastOrder { get; set; }
        public string DepenciesTaskIDEnd { get; set; }
        public string DepenciesTaskIDStart { get; set; }
        public int Carrier { get; set; }
        public string CarrierType { get; set; }
        public int Token { get; set; }
        public bool HasCarrier { get; set; }
        public bool IsCarrierLoading { get; set; }
        public ETaskCarrierState CarrierState { get; set; }
        public int Priority { get; set; }
        public bool Pausing { get; set; }
        public bool CancelRequest { get; set; }
        public bool CanCancel { get; set; }
        public int SystemErrorCode { get; set; }
        public string SystemErrorMessage { get; set; }
        public int UserErrorCode { get; set; }
        public string UserErrorMessage { get; set; }
        public DateTime? CreateTime { get; set; }
        public DateTime? StartTime { get; set; }
        public DateTime? ActualEndTime { get; set; }
        public DateTime? ExpectedEndTime { get; set; }
        public DateTime? EarliestStartTime { get; set; }
        public DateTime? LatestCompletionTime { get; set; }
        public int BindingAGVNumber { get; set; } = 0;
        public string reserved1 { get; set; }
        public string reserved2 { get; set; }
        public string reserved3 { get; set; }
        public string reserved4 { get; set; }
        public string reserved5 { get; set; }
        public string reserved6 { get; set; }
        public string reserved7 { get; set; }


        public string TempLog { get; set; }
    }
}
