﻿using Mapster;
using Prism.Commands;
using Prism.Events;
using Prism.Mvvm;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystemView.Infrastructure.Events;
using ProjectManagementSystemView.Infrastructure.Extensions;
using ProjectManagementSystemView.Infrastructure.Models;
using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystemView.ViewModels
{
    [AddINotifyPropertyChangedInterface]
    public class DebugIOViewModel
    {
        public bool IsVisible { get; set; }
        public ObservableCollection<VmInfoIO> VmDatas { get; set; } = new ObservableCollection<VmInfoIO>();
        public DebugIOViewModel(IEventAggregator eventAggregator)
        {
            eventAggregator.GetEvent<UpdateViewEvent>().Subscribe(UpdateView);
        }

        private void UpdateView()
        {
            if (!IsVisible) return;

            var dataList = DeviceControl.Instance.Communication.InfoIODictionary.Values;

            VmDatas.Update(dataList, (s, v) => s.DeviceId == v.DeviceId);
        }
    }
}
