﻿using Newtonsoft.Json.Linq;
using Prism.Commands;
using ProjectManagementSystem.Common.Core;
using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace ProjectManagementSystemView.ViewModels
{
    [AddINotifyPropertyChangedInterface]
    public class DebugPlcViewModel
    {
        public bool ReadEnabled { get; set; }
        public DelegateCommand ReadCommand { get; set; }
        public ObservableCollection<dynamic> PlcInfoCollection { get; set; }

        public DebugPlcViewModel()
        {
            ReadEnabled = true;
            PlcInfoCollection = new ObservableCollection<dynamic>();
            ReadCommand = new DelegateCommand(Read).ObservesCanExecute(() => ReadEnabled);
        }

        private async void Read()
        {
            ReadEnabled = false;

            try
            {
                PlcInfoCollection.Clear();

                var dataList = await Task.Run(() =>
                {
                    return PlcControl.Instance.ReadPlcInfo();
                });

                dataList.ForEach(p => PlcInfoCollection.Add(p.ToObject<dynamic>()));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "提示", MessageBoxButton.OK, MessageBoxImage.Error);
            }

            ReadEnabled = true;
        }
    }
}
