﻿using HslCommunication.LogNet;
using Prism.Commands;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystemView.ViewModels
{
    [AddINotifyPropertyChangedInterface]
    public class LogViewModel
    {
        public int DisplayDegree { get; set; }
        public string LogDir { get; set; }

        public ObservableCollection<dynamic> DegreeCollection { get; set; }

        public LogViewModel()
        {
            DegreeCollection = new ObservableCollection<dynamic>();

            var allItems = HslMessageDegree.None.GetAllItems<HslMessageDegree>();
            foreach (var item in allItems)
            {
                DegreeCollection.Add(new { Value = (int)item, Display = item.ToString() });
            }

            DisplayDegree = (int)HslMessageDegree.INFO;
            LogDir = CLog.Instance.LogDir;
        }

    }
}
