﻿using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Logger;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ProjectManagementSystemView.Views
{
    /// <summary>
    /// DebugIOView.xaml 的交互逻辑
    /// </summary>
    public partial class DebugIOView : UserControl
    {
        public DebugIOView()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                int deviceId = int.Parse(textBox1.Text);

                ushort newOutput = 0;
                foreach (var item in stackPanel1.Children)
                {
                    if (item is CheckBox checkBox)
                    {
                        int index = int.Parse(checkBox.Content.ToString().Substring(1)) - 1;
                        if (checkBox.IsChecked == true)
                        {
                            newOutput = (ushort)(newOutput | (0x01 << index));
                        }
                        else
                        {
                            newOutput = (ushort)(newOutput & (ushort.MaxValue - (1 << index)));
                        }
                    }
                }

                DeviceControl.Instance.SetOutputIO(deviceId, newOutput);
            }
            catch (Exception ex)
            {
                CLog.Instance.SystemLog.WriteException("UI", ex);
                MessageBox.Show(ex.Message, "提示", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
    }
}
